//*****************************************************************************
//* s^ްޕ
//* ײ  ̧
//*
//* ̧ٖ	: keymatrix.c
//* 		: 1.0
//*
//* ޲	: ATmega162
//* ۯ	: 1MHzRCU
//*
//*****************************************************************************

#include <iom162.h>
#include <inavr.h>
#include "keymatrix.h"
#pragma language=extended

/* ϸۂƒ` */
#define SELECT_POWERDOWN MCUCR |= (1<<SM1)		// ܰ޳ ذߓI邽߂ϸ
#define SELECT_IDLESLEEP MCUCR &= ~(1<<SM1)		//  ذߓI邽߂ϸ

#define ENABLE_PCINT GICR |= (1<<PCIE1)			// ݕω荞݋(PCINT15`8)
#define DISABLE_PCINT GICR &= ~(1<<PCIE1)		// ݕω荞݋֎~

#define COLPORT PORTC							// ߰ďoڼ޽
#define COLPIN PINC								// ߰ēڼ޽
#define COLDIR DDRC								// ߰ĕڼ޽

#define ROWPORT PORTD							// s߰ďoڼ޽
#define ROWPIN PIND								// s߰ēڼ޽
#define ROWDIR DDRD								// s߰ĕڼ޽

/* Sϐ */
volatile unsigned char key_altState;			// ݂̐؂ւ׸
volatile union _key_code key_code;				// ʍ\

/* ײޏ */
//*
//* Kv߰Ăƕϐݒ肵܂Bn܂ײނ~ɍĊJ鎞ɂ
//* gpĂB
//*
void key_init()
{
  /* Sϐ */
  key_altState = 0;								// ؂ւ׸ޏ
  key_code.complete = 0;						// ʏ
  /* ߰ď */
  ROWDIR = 0xFF;								// so͐ݒ
//  ROWPORT = 0x00;								// Ss=Lowo͐ݒ
	
//  COLDIR = 0x00;								// ͐ݒ
  COLPORT = 0xFF;								// Sٱߋ
  /* /0 */
  // (/ꂪ5ms傫Ȃ悤ɐݒ肵ĂB)
  TCCR0 = (1<<CS02) | (0<<CS01) | (0<<CS00);	// 256OuT/C0n(8.2ms/8MHz)
  /* ݕω荞݋ */
  PCMSK1 = 0xFF;								// ߰C(PCINT15`8)Sċ
  ENABLE_PCINT;									// Ήݕω荞݋(PCIE1)
  /* 剞p̂߂ɽذߓw */
  SELECT_POWERDOWN;								// ܰ޳ ذߓw
}

/* ްޑײޒ~ */
//*
//* key_init()ĂьĂ΂܂ŷްޑײނ~܂Bͷްނ
//* KvƂȂꍇɐߓd܂Apgp҂ɂķ邩
//* B
//*
void key_stop()
{
  DISABLE_PCINT;								// ݕω荞݋֎~
  TIMSK &= ~(1<<TOIE0);							// /0ꊄ荞݋֎~
}

/* ҋ@ */
//*
//* ײނɂčXV׸ނݒ(1)̂҂܂B׸ނ(0)
//* đԂ܂Bgp҂͑̏ڍׂɊւkey_codeϐ
//* ׂ邩܂B
//*
unsigned char key_get()
{
  while( !key_code.updated )					// XV׸ނݒ(1)܂ŋx~
  {
	__sleep();									// ذߏԂֈڍs
  }
  key_code.updated = 0;							// XV׸މ(0)
  return key_code.scan;							// ƋɕA
}

/* ݕω荞ݏ */
//*
//* ͍XȂݕω荞݂֎~āAްނ̐ڐG肳邽߂̒Z
//* x҂悤/0܂B]/0ꊄ荞݂
//* 菇܂B
//*
#pragma vector=PCINT1_vect
__interrupt void pinChange1ISR()
{
  DISABLE_PCINT;								// ݕω荞݋֎~(XȂ銄荞ݖh~)
  /* /0ł̒x */
  TCNT0 = 0;									// /0l
  TIMSK |= (1<<TOIE0);							// /0ꊄ荞݋
  SELECT_IDLESLEEP;								// T/C0xͱ ذߓwɕύX
}

/* ؂ւ */
//*
//* ͐ꂽ\ߒ`Ă؂ւƔrAɉ
//* ׸ނXV܂B/0ꊄ荞݂s܂B
//*
#ifdef ALTKEYS
void key_processAltKeys()
{
  key_code.flags = key_altState | 0x80;			// ؂ւ׸ޕۑ(XV׸ސݒ(1))

  if     ( key_code.scan == ALTKEY0 ) key_altState ^= (1<<0);	// ؂ւ0ŁA؂ւ0׸ޔ]
  else if( key_code.scan == ALTKEY1 ) key_altState ^= (1<<1);	// ؂ւ1ŁA؂ւ1׸ޔ]
  else if( key_code.scan == ALTKEY2 ) key_altState ^= (1<<2);	// ؂ւ2ŁA؂ւ2׸ޔ]
  else if( key_code.scan == ALTKEY3 ) key_altState ^= (1<<3);	// ؂ւ3ŁA؂ւ3׸ޔ]
  else if( key_code.scan == LCKKEY0 ) key_altState ^= (1<<4);	// Œ艻0ŁAŒ艻0׸ޔ]
  else if( key_code.scan == LCKKEY1 ) key_altState ^= (1<<5);	// Œ艻1ŁAŒ艻1׸ޔ]
  else if( key_code.scan == LCKKEY2 ) key_altState ^= (1<<6);	// Œ艻2ŁAŒ艻2׸ޔ]
  else											// ؂ւȊO(ʏ)ŁA
  {
	key_altState &= ALTLOCKMASK;				// P ׸މ(0)
  }
}
#endif

/* /0ꊄ荞ݏ */
//*
//* ͷްނ𑖍Ăǂꂩ̷܂B؂ւ׸ނXV
//* BŌɍXȂ鷰ω҂߂ݕω荞݂ċ܂B
//*
#pragma vector=TIMER0_OVF_vect
__interrupt void timer0OVFISR()
{
  /* Local variables */
  unsigned char lineResult;						// sƗ̎擾l
  unsigned char tempScan;						// ꎞIȑ

  PORTB |= 1;									// [p]PB0=High
  PORTB &= ~1;									// [p]PB0=Low

  /* /0ꊄ荞݋֎~ */
  TIMSK &= ~(1<<TOIE0);							// /0ꊄ荞݋֎~
  /* ł̷ */
  lineResult = COLPIN;							// l擾
  if( lineResult != 0xFF )						// ꂩ̗񉟉(Low)ŁA
  {
	/* ߰ĕ] */
	ROWPORT = 0xFF;								// Ssٱߋ(:̎_łHigho)
	COLPORT = 0x00;								// SLowo͐ݒ(:̎_ł͓ٱߋ֎~)
	ROWDIR = 0x00;								// Ss͐ݒ
	COLDIR = 0xFF;								// So͐ݒ

	tempScan = 0;								// ꎞl
	while( lineResult & 0x01 )					// Low̗o܂Ōp
	{
	  lineResult >>= 1;							// ޯĂLSBֈړ
	  tempScan++;								// ꎞ̗񕔔ԍis
	}
	/* sł̷ */
	lineResult = ROWPIN;						// sl擾
	/* ߰ĕɉ */
	COLPORT = 0xFF;								// Sٱߋ(:̎_łHigho)
	ROWPORT = 0x00;								// SsLowo͐ݒ(:̎_ł͓ٱߋ֎~)
	COLDIR = 0x00;								// S͐ݒ
	ROWDIR = 0xFF;								// Sso͐ݒ

	if( lineResult != 0xFF )					// ꂩ̍s(Low)ŁA
	{
	  while( lineResult & 0x01 )				// Low̍so܂Ōp
	  {
		lineResult >>= 1;						// sޯĂLSBֈړ
		tempScan += 8;							// ꎞ̍sԍis
	  }
	  /*  */
	  key_code.scan = tempScan;					// ۑ/ݒ
	  key_code.updated = 1;						// XV׸ސݒ(1)
#ifdef ALTKEYS
	  key_processAltKeys();						// w肳ĂȂA؂ւ
#endif
	} else										// ǂ̍sł(Low)ȂŁA
	{
	  key_code.scan = 0xFF;						// Ȃݒ
	}
		
  } else										// ǂ̗ł(Low)ȂŁA
  {
	key_code.scan = 0xFF;						// Ȃݒ
  }
  /* ݕω荞ݏ */
  ENABLE_PCINT;									// ݕω荞ݍċ
  GIFR |= PCIF1;								// ݕω荞ݗv׸މ(0)
  SELECT_POWERDOWN;								// ܰ޳ ذߓwɉ
}
